remove kinsis / unused input settings
[distro-setup] / btrbk-run
index eb8a7b5db7e9c89ea051095f55399de541d7e31d..5ff83260022c20d1eeec2217ae8392b61653b69d 100755 (executable)
--- a/btrbk-run
+++ b/btrbk-run
@@ -13,6 +13,9 @@
 # See the License for the specific language governing permissions and
 # limitations under the License.
 
+
+# todo: remove old leaf subvols, like keep up to 1 month or something.
+
 set -eE -o pipefail
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
@@ -30,7 +33,6 @@ script_dir=$(dirname $(readlink -f "$BASH_SOURCE"))
 # note p/m is owned 1000:1000 and chmod 700
 
 
-targets=()
 mountpoints=()
 
 rsync_mountpoint=/q
@@ -38,43 +40,53 @@ rsync_mountpoint=/q
 conf_only=false
 dry_run=false # mostly for testing
 resume_arg=
+rate_limit=no
+verbose=false
 
 default_args_file=/etc/btrbk-run.conf
 if [[ -s $default_args_file ]]; then
-    echo "$0: warning: options file default options set:"
-    cat $default_args_file
-    sleep 5
     set -- $(< $default_args_file) "$@"
 fi
 
-temp=$(getopt -l help hcm:nprt: "$@") || usage 1
+temp=$(getopt -l help cl:m:nprt:vh "$@") || usage 1
 eval set -- "$temp"
 while true; do
     case $1 in
+        # only creates the config file, does not run btrbk
         -c) conf_only=true; shift ;;
+        -l) rate_limit=$2; shift 2 ;;
         -m) IFS=, mountpoints=($2); unset IFS; shift 2 ;;
         -n) dry_run=true; dry_run_arg=-n; shift ;;
         -p) progress_arg="--progress"; shift ;;
         # btrbk arg: Resume only. Skips snapshot creation.
         -r) resume_arg=-r; shift ;;
+        # empty is valid for just doing local snapshot. we have default hosts
+        # we will populate
         -t) IFS=, targets=($2); unset IFS; shift 2 ;;
+        -v) verbose=true; verbose_arg=-v; shift ;;
         -h|--help) usage ;;
         --) shift; break ;;
         *) echo "$0: Internal error!" ; exit 1 ;;
     esac
 done
 
-echo "$0: options: conf_only=$conf_only, dry_run=$dry_run, resume_arg=$resume_arg"
+if [[ -s $default_args_file ]]; then
+    echo "$0: warning: default btrbk-run options set in $default_args_file (sleeping 5 seconds):"
+    cat $default_args_file
+    sleep 5
+fi
+
+echo -e "$0: options: conf_only=$conf_only\ndry_run=$dry_run\nresume_arg=$resume_arg\nrate_limit=$rate_limit\nverbose=$verbose"
 
 # set default targets
-if ! (( ${#targets[@]} )); then
+if [[ ! -v targets ]]; then
     case $HOSTNAME in
-        x2)
+        x2|fz)
             if [[ $HOSTNAME == "$MAIL_HOST" ]]; then
                 targets=($HOME_DOMAIN)
             fi
             ;;
-        treetowl)
+        tp)
             targets=(frodo)
             if [[ $HOSTNAME == "$MAIL_HOST" ]]; then
                 if timeout -s 9 10 ssh x2 :; then
@@ -82,6 +94,9 @@ if ! (( ${#targets[@]} )); then
                 fi
             fi
             ;;
+        frodo)
+            targets=()
+            ;;
         *)
             echo "$0: error: no default targets for this host, use -t"
             exit 1
@@ -93,18 +108,36 @@ echo "targets: ${targets[*]}"
 
 
 
-# set default mountpoints
-if ! (( ${#mountpoints[@]} )); then
-    prospective_mps=(/a /q)
-    if [[ $HOSTNAME == "$MAIL_HOST" ]]; then
-        prospective_mps+=(/o)
-    fi
-    for tg in ${targets[@]}; do
-        if [[ $tg == frodo && $HOSTNAME == treetowl ]]; then
-            prospective_mps+=(/i)
+if (( ${#mountpoints[@]} )); then
+    for mp in ${mountpoints[@]}; do
+        if [[ -e /nocow/btrfs-stale/$mp ]]; then
+            echo "$0: warning: $mp stale. Sleeping for 3 seconds in case you want to cancel."
+            sleep 3
         fi
     done
+else # set default mountpoints
+    case $HOSTNAME in
+        frodo)
+            prospective_mps=(/i)
+            ;;
+        *)
+            prospective_mps=(/a /q)
+            if [[ $HOSTNAME == "$MAIL_HOST" ]]; then
+                prospective_mps+=(/o)
+            fi
+            ;;
+    esac
+    case ${targets[0]} in
+        kw|kww)
+            prospective_mps=(/a)
+            ;;
+    esac
+
     for mp in ${prospective_mps[@]}; do # default mountpoints to sync
+        if [[ -e /nocow/btrfs-stale/$mp ]]; then
+            echo "$0: warning: $mp stale, not adding to default mountpoints"
+            continue
+        fi
         if awk '{print $2}' /etc/fstab | grep -xF $mp &>/dev/null; then
             mountpoints+=($mp)
         fi
@@ -143,8 +176,8 @@ if ! which btrbk &>/dev/null; then
     echo "$0: error: no btrbk binary found"
 fi
 
-cat >/etc/btrbk.conf <<'EOF'
-ssh_identity /root/.ssh/id_rsa
+cat >/etc/btrbk.conf <<EOF
+ssh_identity /root/.ssh/home
 # Just a guess that local7 is a good facility to pick.
 # It's a bit odd that the transaction log has to be logged to
 # a file or syslog, while other output is sent to std out.
@@ -174,6 +207,8 @@ target_preserve_min 4h
 
 # if something fails and it's not obvious, try doing
 # btrbk -l debug -v dryrun
+
+rate_limit $rate_limit
 EOF
 
 
@@ -218,11 +253,11 @@ if $conf_only; then
 fi
 
 if $dry_run; then
-    m btrbk -n $resume_arg run
+    m btrbk -v -n $resume_arg run
 else
     # -q and just using the syslog option seemed nice,
     # but it doesn't show when a send has a parent and when it doesn't.
-    m btrbk $progress_arg $resume_arg run
+    m btrbk $verbose_arg $progress_arg $resume_arg run
 fi
 
 # if we have it, sync to systems which don't